/*
 *  Panel.java
 *  SwingOSC
 *
 *  Copyright (c) 2005-2006 Hanns Holger Rutz. All rights reserved.
 *
 *	This software is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	as published by the Free Software Foundation; either
 *	version 2, june 1991 of the License, or (at your option) any later version.
 *
 *	This software is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *	General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public
 *	License (gpl.txt) along with this software; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 *	For further information, please contact Hanns Holger Rutz at
 *	contact@sciss.de
 *
 *
 *  Changelog:
 *		12-Nov-05	created
 */

package de.sciss.swingosc;

import java.awt.*;
import java.awt.geom.*;
import javax.swing.*;

// an attempt to get gradient backgrounds working
// not yet finished
public class Panel
extends JPanel
{
	private GradientPaint	pntCustomBgProto	= null;
	private GradientPaint	pntCustomBg			= null;
	private int				recentWidth			= -1;
	private int				recentHeight		= -1;
	
	public Panel( LayoutManager layout, boolean isDoubleBuffered )
	{
		super( layout, isDoubleBuffered );
		init();
	}
			  
	public Panel( LayoutManager layout )
	{
		super( layout );
		init();
	}

	public Panel( boolean isDoubleBuffered )
	{
		super( isDoubleBuffered );
		init();
	}

	public Panel()
	{
		super();
		init();
	}
	
	private void init()
	{
//		defaultOpaque	= isOpaque();
//setDoubleBuffered( false );
	}

	public void setBackground( Color c )
	{
		pntCustomBgProto	= null;
		pntCustomBg			= null;
//		setOpaque( defaultOpaque );
		super.setBackground( c );
	}

	public void setBackground( GradientPaint pnt )
	{
		pntCustomBgProto	= pnt;
		recentWidth			= -1;	// triggers recalc
//		setOpaque( true );

		super.setBackground( null );
	}
	
//public boolean isOptimizedDrawingEnabled() { return false; }
	
	private void recalcGradientPaint()
	{
		final Point2D	pt1	= pntCustomBgProto.getPoint1();
		final Point2D	pt2	= pntCustomBgProto.getPoint2();
		pntCustomBg			= new GradientPaint(
			new Point( (int) (pt1.getX() * recentWidth), (int) (pt1.getY() * recentHeight) ), pntCustomBgProto.getColor1(),
			new Point( (int) (pt2.getX() * recentWidth), (int) (pt2.getY() * recentHeight) ), pntCustomBgProto.getColor2() );
	}

	public void paintChildren( Graphics g )
	{		
		if( pntCustomBgProto != null ) {
			final int w	= getWidth();
			final int h	= getHeight();

			if( (recentWidth != w) || (recentHeight != h) ) {
				recentWidth		= w;
				recentHeight	= h;
				recalcGradientPaint();
				
				final Graphics2D g2 = (Graphics2D) g;
				
				g2.setPaint( pntCustomBg );
				g2.fillRect( 0, 0, w, h );
			}
		}

		super.paintChildren( g );
	}
	
	public void paintBorder( Graphics g )
	{		
		super.paintBorder( g );

		if( pntCustomBgProto != null ) {
			final int w	= getWidth();
			final int h	= getHeight();

			if( (recentWidth != w) || (recentHeight != h) ) {
				recentWidth		= w;
				recentHeight	= h;
				recalcGradientPaint();
				
				final Graphics2D g2 = (Graphics2D) g;
				
				g2.setPaint( pntCustomBg );
				g2.fillRect( 0, 0, w, h );
			}
		}
	}

	public void paintComponent( Graphics g )
	{
		super.paintComponent( g );
		
		if( pntCustomBgProto != null ) {
			final int w	= getWidth();
			final int h	= getHeight();

			if( (recentWidth != w) || (recentHeight != h) ) {
				recentWidth		= w;
				recentHeight	= h;
				recalcGradientPaint();
				
				final Graphics2D g2 = (Graphics2D) g;
				
				g2.setPaint( pntCustomBg );
				g2.fillRect( 0, 0, w, h );
			}
		}
	}
}